# Debit Memos Debit memos increase the amount a customer owes. It is a separate document from the invoice. Debit memos can be used to correct undercharging on an invoice or to levy ad hoc charges outside the context of a subscription. Just like an invoice, debit memo balances can be settled by applying either a payment or a credit memo. For more information about debit memos, see Credit and debit memos. ## List debit memos - [GET /v1/debit-memos](https://developer.zuora.com/v1-api-reference/api/debit-memos/get_debitmemos.md): Note: This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information. Retrieves the information about all debit memos associated with all customer accounts. ### Filtering You can use query parameters to restrict the data returned in the response. Each query parameter corresponds to one field in the response body. If the value of a filterable field is string, you can set the corresponding query parameter to null when filtering. Then, you can get the response data with this field value being null. Examples: - /v1/debit-memos?status=Posted - /v1/debit-memos?referredInvoiceId=null&status=Draft - /v1/debit-memos?status=Posted&type=External&sort=+number ## Create a debit memo from a charge - [POST /v1/debit-memos](https://developer.zuora.com/v1-api-reference/api/debit-memos/post_debitmemofromprpc.md): Note: This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information. Creates an ad-hoc debit memo from a product rate plan charge. Zuora supports the creation of debit memos from any type of product rate plan charge. The charges can also have any amount and any charge model, except for discout charge models. When debit memos are created from product rate plan charges, the specified amount with decimal places is now validated based on the decimal places supported by each currency. You can create a debit memo only if you have the user permission. See Billing Roles for more information. ## Update due dates for debit memos - [PUT /v1/debit-memos](https://developer.zuora.com/v1-api-reference/api/debit-memos/put_updatedebitmemosduedates.md): Note: This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information. Updates the due date for multiple debit memos in one single request. This API operation will be deprecated. You can use the Update debit memos instead, which provides more flexible functionality. ## Create debit memos - [POST /v1/debit-memos/bulk](https://developer.zuora.com/v1-api-reference/api/debit-memos/post_createdebitmemos.md): Note: This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information. Creates multiple debit memos from invoices or product rate plan charges. You can create a maximum of 50 debit memos in one single request. - If you set the sourceType request field to Invoice, you can create multiple debit memos from invoices. - If you set the sourceType request field to Standalone, you can create multiple debit memos from product rate plan charges. The debit memos that are created are each in separate database transactions. If the creation of one debit memo fails, other debit memos can still be created successfully. You can create debit memos only if you have the user permission. See Billing Roles for more information. ## Update debit memos - [PUT /v1/debit-memos/bulk](https://developer.zuora.com/v1-api-reference/api/debit-memos/put_updatedebitmemos.md): Notes: - This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information. - You can update debit memos only if you have the user permission. See Billing Roles for more information. Updates the basic and finance information about multiple debit memos. You can update a maximum of 50 credit memos in one single request. Currently, Zuora supports updating tax-exclusive memo items, but does not support updating tax-inclusive memo items. If the amount of a memo item is updated, the tax will be recalculated in the following conditions: - The memo is created from a product rate plan charge and you use Avalara to calculate the tax. - The memo is created from an invoice and you use Avalara or Zuora Tax to calculate the tax. The Edit credit and debit memos tutorial demonstrates how to use this operation to add and delete memo items. The credit memos that are updated are each in separate database transactions. If the update of one debit memo fails, other debit memos can still be updated successfully. ## Retrieve the PDF file generation status of debit memos - [GET /v1/debit-memos/pdf-status](https://developer.zuora.com/v1-api-reference/api/debit-memos/get_debitmemopdfstatus.md): Retrieves the PDF generation statuses of a batch of debit memos. ## List all application parts of a debit memo - [GET /v1/debit-memos/{debitMemoId}/application-parts](https://developer.zuora.com/v1-api-reference/api/debit-memos/get_debitmemoapplicationparts.md): Note: This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information. Retrieves information about the payments or credit memos that are applied to a specified debit memo. If you use the Zuora version 341.0 or a later available version, this operation will return only processed payments applied to the debit memos. For Zuora versions earlier than 341.0, it returns all payments associated with the debit memo regardless of the payment status. ## List all taxation items of a debit memo item - [GET /v1/debit-memos/{debitMemoId}/items/{dmitemid}/taxation-items](https://developer.zuora.com/v1-api-reference/api/debit-memos/get_taxationitemsofdebitmemoitem.md): Note: This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information. Retrieves information about the taxation items of a specific debit memo item. ## Delete a debit memo - [DELETE /v1/debit-memos/{debitMemoKey}](https://developer.zuora.com/v1-api-reference/api/debit-memos/delete_debitmemo.md): Note: This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information. Deletes a debit memo. Only debit memos with the Cancelled status can be deleted. You can delete a debit memo only if you have the user permission. See Billing Roles for more information. The Edit credit and debit memos tutorial demonstrates how to use this operation to add and delete memo items. ## Retrieve a debit memo - [GET /v1/debit-memos/{debitMemoKey}](https://developer.zuora.com/v1-api-reference/api/debit-memos/get_debitmemo.md): Note: This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information. Retrieves the information about a specific debit memo. ## Update a debit memo - [PUT /v1/debit-memos/{debitMemoKey}](https://developer.zuora.com/v1-api-reference/api/debit-memos/put_debitmemo.md): Notes: - This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information. - You can update a debit memo only if you have the user permission. See Billing Roles for more information. Updates the basic and finance information about a debit memo. Currently, Zuora supports updating tax-exclusive memo items, but does not support updating tax-inclusive memo items. If the amount of a memo item is updated, the tax will be recalculated in the following conditions: - The memo is created from a product rate plan charge and you use Avalara to calculate the tax. - The memo is created from an invoice and you use Avalara or Zuora Tax to calculate the tax. The Edit credit and debit memos tutorial demonstrates how to use this operation to add and delete memo items. ## Cancel a debit memo - [PUT /v1/debit-memos/{debitMemoKey}/cancel](https://developer.zuora.com/v1-api-reference/api/debit-memos/put_canceldebitmemo.md): Note: This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information. Cancels a debit memo. Only debit memos with the Draft status can be cancelled. You can cancel a debit memo only if you have the user permission. See Billing Roles for more information. ## Collect a posted debit memo - [POST /v1/debit-memos/{debitMemoKey}/collect](https://developer.zuora.com/v1-api-reference/api/debit-memos/post_debitmemocollect.md): Note: This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information. This API operation provides an easy way to let the client-side to collect an existing posted debit memo. It supports the following steps: 1. Apply unapplied credit memos to the posted debit memo by Oldest-First-Largest-First rule if there are more than one unapplied credit memos. 2. Apply unapplied payments to the posted debit memo by Oldest-First-Largest-First rule if there are more than one unapplied payments. 3. Process payment to the posted debit memo if there is an open-balance on it. Restrictions Since this API will do lots of works, and some of them are resource consuming, we need to restrict the usage of this API by the following conditions: 1. If the target debit memo gets more than 10 debit memo items, the request will be rejected. 2. If CreditMemo is specified in applicationOrder, when there are more than 25 credit memos will be used to apply to the debit memo, the request will be rejected. 3. If CreditMemo is specified in applicationOrder, when there are more than 100 credit memo items will be used to apply to the debit memo, the request will be rejected. 4. If UnappliedPayment is specified in applicationOrder, when there are more than 25 payments will be used to apply to the debit memo, the request will be rejected. ## Email a debit memo - [POST /v1/debit-memos/{debitMemoKey}/emails](https://developer.zuora.com/v1-api-reference/api/debit-memos/post_emaildebitmemo.md): Note: This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information. Sends a posted debit memo to the specified email addresses manually. ### Notes - You must activate the Email Debit Memo | Manually email Debit Memo notification before emailing debit memos. To include the debit memo PDF in the email, select the Include Debit Memo PDF check box in the Edit notification dialog from the Zuora UI. See Create and Edit Notifications for more information. - Zuora sends the email messages based on the email template you set. You can set the email template to use in the Delivery Options panel of the Edit notification dialog from the Zuora UI. By default, the Manual Email for Debit Memo Default Template template is used. See Create and Edit Email Templates for more information. - The debit memos are sent only to the work email addresses or personal email addresses of the Bill To contact if the following conditions are all met: * The useEmailTemplateSetting field is set to false. * The email addresses are not specified in the emailAddresses field. ## Upload a file for a debit memo - [POST /v1/debit-memos/{debitMemoKey}/files](https://developer.zuora.com/v1-api-reference/api/debit-memos/post_uploadfilefordebitmemo.md): Note: This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information. Uploads an externally generated PDF file for a debit memo that is in Draft or Posted status. To use this operation, you must enable the Modify Debit Memo permission. See Billing Permissions for more information. This operation has the following restrictions: - Only the PDF file format is supported. - The maximum size of the PDF file to upload is 4 MB. - A maximum of 50 PDF files can be uploaded for one debit memo. ## List all files of a debit memo - [GET /v1/debit-memos/{debitMemoKey}/files](https://developer.zuora.com/v1-api-reference/api/debit-memos/get_debitmemofiles.md): Retrieves the information about all PDF files of a specified debit memo. Debit Memo PDF files are returned in reverse chronological order by the value of the versionNumber field. Note: This API only retrieves the PDF files that have been generated. If the latest PDF file is being generated, it will not be included in the response. ## List debit memo items - [GET /v1/debit-memos/{debitMemoKey}/items](https://developer.zuora.com/v1-api-reference/api/debit-memos/get_debitmemoitems.md): Note: This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information. Retrieves the information about all items of a debit memo. A debit memo item is a single line item in a debit memo. ### Filtering You can use query parameters to restrict the data returned in the response. Each query parameter corresponds to one field in the response body. If the value of a filterable field is string, you can set the corresponding query parameter to null when filtering. Then, you can get the response data with this field value being null. Examples: - /v1/debit-memos/402890245c7ca371015c7cb40b28001f/items?amount=100 - /v1/debit-memos/402890245c7ca371015c7cb40b28001f/items?amount=100&sort=createdDate ## Retrieve a debit memo item - [GET /v1/debit-memos/{debitMemoKey}/items/{dmitemid}](https://developer.zuora.com/v1-api-reference/api/debit-memos/get_debitmemoitem.md): Note: This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information. Retrieves information about a specific item of a debit memo. A debit memo item is a single line item in a debit memo. ## Generate a debit memo PDF file - [POST /v1/debit-memos/{debitMemoKey}/pdfs](https://developer.zuora.com/v1-api-reference/api/debit-memos/post_debitmemopdf.md): Note: This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information. Creates a PDF file for a specified debit memo. To access the generated PDF file, you can download it by clicking View PDF on the detailed debit memo page through the Zuora UI. This REST API operation can be used only if you have the billing document file generation feature and the Billing user permission "Regenerate PDF" enabled. ## Post a debit memo - [PUT /v1/debit-memos/{debitMemoKey}/post](https://developer.zuora.com/v1-api-reference/api/debit-memos/put_postdebitmemo.md): Note: This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information. Posts a debit memo to activate it. You can post debit memos only if you have the Billing permissions. ## Create taxation items for a debit memo - [POST /v1/debit-memos/{debitMemoKey}/taxation-items](https://developer.zuora.com/v1-api-reference/api/debit-memos/post_dm_taxationitems.md): Note: This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information. Creates taxation items for a debit memo. ## Unpost a debit memo - [PUT /v1/debit-memos/{debitMemoKey}/unpost](https://developer.zuora.com/v1-api-reference/api/debit-memos/put_unpostdebitmemo.md): Note: This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information. Unposts a debit memo that is in Posted status. If any credit memo or payment has been applied to a debit memo, you are not allowed to unpost the debit memo. After a debit memo is unposted, its status becomes Draft. You can unpost debit memos only if you have the Billing permissions. You can prevent an unpost operation by configuring the 'Do not allow unposting invoices and memos if their revenue is already recognized in a closed accounting period' accounting rule. The default value of this rule is set to 'disabled.' For more information, see Configure Accounting Rules. ## Create a debit memo from an invoice - [POST /v1/debit-memos/invoice/{invoiceKey}](https://developer.zuora.com/v1-api-reference/api/debit-memos/post_debitmemofrominvoice.md): Note: This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information. Creates an ad-hoc debit memo from an invoice. You can create a debit memo from an invoice only if you have the user permission. See Billing Roles for more information. ## Write off a debit memo - [PUT /v1/debit-memos/{debitMemoKey}/write-off](https://developer.zuora.com/v1-api-reference/api/debit-memos/put_writeoffdebitmemo.md): Note: This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information. Writes off a debit memo. By writing off a debit memo, a credit memo is automatically created and applied to the debit memo. The generated credit memo items and credit memo taxation items are applied to the corresponding debit memo items and debit memo taxation items respectively. Note: * This API operation is available only if you have enabled the enhanced write-off permission for your tenant. Contact Zuora Global Support to enable this permission. * The total amount must be equal to the amount entered at the invoice item level. * If the non revenue impact value is set to Yes, then the non revenue write off accounting code must be specified.